// Generated by gmmproc 2.46.1 -- DO NOT MODIFY!


#include <glibmm.h>

#include <goocanvasmm/pathmodel.h>
#include <goocanvasmm/private/pathmodel_p.h>


/* Copyright (C) 1998-2006 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <goocanvaspath.h>


namespace Goocanvas
{

PathModel::PathModel(const Glib::ustring& data)
:
  // Mark this class as non-derived to allow C++ vfuncs to be skipped.
  Glib::ObjectBase(0),
  Goocanvas::ItemModelSimple(Glib::ConstructParams(pathmodel_class_.init(), "data",const_cast<char*>(data.c_str()), static_cast<char*>(0)))
{
}

} //namespace Goocanvas


namespace
{
} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Goocanvas::PathModel> wrap(GooCanvasPathModel* object, bool take_copy)
{
  return Glib::RefPtr<Goocanvas::PathModel>( dynamic_cast<Goocanvas::PathModel*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Goocanvas
{


/* The *_Class implementation: */

const Glib::Class& PathModel_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &PathModel_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(goo_canvas_path_model_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:

  }

  return *this;
}


void PathModel_Class::class_init_function(void* g_class, void* class_data)
{
  const auto klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);


}


Glib::ObjectBase* PathModel_Class::wrap_new(GObject* object)
{
  return new PathModel((GooCanvasPathModel*)object);
}


/* The implementation: */

GooCanvasPathModel* PathModel::gobj_copy()
{
  reference();
  return gobj();
}

PathModel::PathModel(const Glib::ConstructParams& construct_params)
:
  Goocanvas::ItemModelSimple(construct_params)
{

}

PathModel::PathModel(GooCanvasPathModel* castitem)
:
  Goocanvas::ItemModelSimple((GooCanvasItemModelSimple*)(castitem))
{}


PathModel::PathModel(PathModel&& src) noexcept
: Goocanvas::ItemModelSimple(std::move(src))
{}

PathModel& PathModel::operator=(PathModel&& src) noexcept
{
  Goocanvas::ItemModelSimple::operator=(std::move(src));
  return *this;
}

PathModel::~PathModel() noexcept
{}


PathModel::CppClassType PathModel::pathmodel_class_; // initialize static member

GType PathModel::get_type()
{
  return pathmodel_class_.init().get_type();
}


GType PathModel::get_base_type()
{
  return goo_canvas_path_model_get_type();
}


Glib::RefPtr<PathModel> PathModel::create(const Glib::ustring& data)
{
  return Glib::RefPtr<PathModel>( new PathModel(data) );
}


Glib::PropertyProxy_WriteOnly< Glib::ustring > PathModel::property_data() 
{
  return Glib::PropertyProxy_WriteOnly< Glib::ustring >(this, "data");
}


} // namespace Goocanvas


